> ## Documentation Index
> Fetch the complete documentation index at: https://docs.conductor.is/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a credit card credit

> Creates a new credit card credit for the specified account.



## OpenAPI

````yaml POST /quickbooks-desktop/credit-card-credits
openapi: 3.1.0
info:
  title: Conductor API
  version: 0.0.1
servers:
  - url: https://api.conductor.is/v1
security:
  - BearerAuth: []
paths:
  /quickbooks-desktop/credit-card-credits:
    post:
      summary: Create a credit card credit
      description: Creates a new credit card credit for the specified account.
      parameters:
        - in: header
          name: Conductor-End-User-Id
          description: The ID of the End-User to receive this request.
          schema:
            type: string
            description: The ID of the End-User to receive this request.
            example: end_usr_1234567abcdefg
            x-stainless-naming:
              typescript:
                method_argument: conductorEndUserId
              mcp:
                method_argument: conductorEndUserId
          required: true
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                accountId:
                  type: string
                  description: >-
                    The bank or credit card account to which this credit card
                    credit is posted.
                  example: 80000001-1234567890
                payeeId:
                  type: string
                  description: >-
                    The vendor or company from whom this credit card credit was
                    received for purchased merchandise or services.
                  example: 80000001-1234567890
                transactionDate:
                  type: string
                  format: date
                  description: >-
                    The date of this credit card credit, in ISO 8601 format
                    (YYYY-MM-DD).
                  example: '2024-10-01'
                refNumber:
                  type: string
                  description: >-
                    The case-sensitive user-defined reference number for this
                    credit card credit, which can be used to identify the
                    transaction in QuickBooks. This value is not required to be
                    unique and can be arbitrarily changed by the QuickBooks
                    user. When left blank in this create request, this field
                    will be left blank in QuickBooks (i.e., it does *not*
                    auto-increment).
                  example: CREDIT-1234
                memo:
                  type: string
                  description: A memo or note for this credit card credit.
                  example: Refund for returned office supplies
                salesTaxCodeId:
                  type: string
                  description: >-
                    The sales-tax code for this credit card credit, determining
                    whether it is taxable or non-taxable. If set, this overrides
                    any sales-tax codes defined on the payee. This can be
                    overridden on the credit card credit's individual lines.


                    Default codes include "Non" (non-taxable) and "Tax"
                    (taxable), but custom codes can also be created in
                    QuickBooks. If QuickBooks is not set up to charge sales tax
                    (via the "Do You Charge Sales Tax?" preference), it will
                    assign the default non-taxable code to all sales.
                  example: 80000001-1234567890
                exchangeRate:
                  type: number
                  description: >-
                    The market exchange rate between this credit card credit's
                    currency and the home currency in QuickBooks at the time of
                    this transaction. Represented as a decimal value (e.g.,
                    1.2345 for 1 EUR = 1.2345 USD if USD is the home currency).
                  example: 1.2345
                externalId:
                  type: string
                  format: uuid
                  description: >-
                    A globally unique identifier (GUID) you, the developer, can
                    provide for tracking this object in your external system.
                    This field is immutable and can only be set during object
                    creation.


                    **IMPORTANT**: This field must be formatted as a valid GUID;
                    otherwise, QuickBooks will return an error.
                  example: 12345678-abcd-1234-abcd-1234567890ab
                expenseLines:
                  type: array
                  items:
                    type: object
                    properties:
                      accountId:
                        type: string
                        description: >-
                          The expense account being debited (increased) for this
                          expense line. The corresponding account being credited
                          is usually a liability account (e.g.,
                          Accounts-Payable) or an asset account (e.g., Cash),
                          depending on the transaction type.
                        example: 80000001-1234567890
                      amount:
                        type: string
                        description: >-
                          The monetary amount of this expense line, represented
                          as a decimal string.
                        example: '1000.00'
                      memo:
                        type: string
                        description: A memo or note for this expense line.
                        example: New office chair
                      payeeId:
                        type: string
                        description: >-
                          If `account` refers to an Accounts-Payable (A/P)
                          account, `payee` refers to the expense's vendor (not
                          the customer). If `account` refers to any other type
                          of account, `payee` refers to the expense's customer
                          (not the vendor).
                        example: 80000001-1234567890
                      classId:
                        type: string
                        description: >-
                          The expense line's class. Classes can be used to
                          categorize objects into meaningful segments, such as
                          department, location, or type of work. In QuickBooks,
                          class tracking is off by default. If a class is
                          specified for the entire parent transaction, it is
                          automatically applied to all expense lines unless
                          overridden here, at the transaction line level.
                        example: 80000001-1234567890
                      salesTaxCodeId:
                        type: string
                        description: >-
                          The sales-tax code for this expense line, determining
                          whether it is taxable or non-taxable. If set, this
                          overrides any sales-tax codes defined on the parent
                          transaction or the associated item.


                          Default codes include "Non" (non-taxable) and "Tax"
                          (taxable), but custom codes can also be created in
                          QuickBooks. If QuickBooks is not set up to charge
                          sales tax (via the "Do You Charge Sales Tax?"
                          preference), it will assign the default non-taxable
                          code to all sales.
                        example: 80000001-1234567890
                      billingStatus:
                        type: string
                        enum:
                          - billable
                          - has_been_billed
                          - not_billable
                        description: The billing status of this expense line.
                        example: billable
                        default: billable
                      salesRepresentativeId:
                        type: string
                        description: >-
                          The expense line's sales representative. Sales
                          representatives can be employees, vendors, or other
                          names in QuickBooks.
                        example: 80000001-1234567890
                      customFields:
                        type: array
                        items:
                          type: object
                          properties:
                            ownerId:
                              type: string
                              description: >-
                                The identifier of the owner of the custom field,
                                which QuickBooks internally calls a "data
                                extension". For public custom fields visible in
                                the UI, such as those added by the QuickBooks
                                user, this is always "0". For private custom
                                fields that are only visible to the application
                                that created them, this is a valid GUID
                                identifying the owning application. Internally,
                                Conductor always fetches all public custom
                                fields (those with an `ownerId` of "0") for all
                                objects.
                              example: '0'
                            name:
                              type: string
                              description: >-
                                The name of the custom field, unique for the
                                specified `ownerId`. For public custom fields,
                                this name is visible as a label in the
                                QuickBooks UI.
                              example: Customer Rating
                            value:
                              type: string
                              description: >-
                                The value of this custom field. The maximum
                                length depends on the field's data type.
                              example: Premium
                          required:
                            - ownerId
                            - name
                            - value
                          additionalProperties: false
                        minItems: 1
                        description: >-
                          The custom fields for the expense line object, added
                          as user-defined data extensions, not included in the
                          standard QuickBooks object.
                    additionalProperties: false
                  minItems: 1
                  description: >-
                    The credit card credit's expense lines, each representing
                    one line in this expense.
                itemLines:
                  type: array
                  items:
                    type: object
                    properties:
                      itemId:
                        type: string
                        description: >-
                          The item associated with this item line. This can
                          refer to any good or service that the business buys or
                          sells, including item types such as a service item,
                          inventory item, or special calculation item like a
                          discount item or sales-tax item.
                        example: 80000001-1234567890
                      inventorySiteId:
                        type: string
                        description: >-
                          The site location where inventory for the item
                          associated with this item line is stored.
                        example: 80000001-1234567890
                      inventorySiteLocationId:
                        type: string
                        description: >-
                          The specific location (e.g., bin or shelf) within the
                          inventory site where the item associated with this
                          item line is stored.
                        example: 80000001-1234567890
                      serialNumber:
                        type: string
                        description: >-
                          The serial number of the item associated with this
                          item line. This is used for tracking individual units
                          of serialized inventory items.
                        example: SN1234567890
                      lotNumber:
                        type: string
                        description: >-
                          The lot number of the item associated with this item
                          line. Used for tracking groups of inventory items that
                          are purchased or manufactured together.
                        example: LOT2023-001
                      expirationDate:
                        type: string
                        format: date
                        description: >-
                          The expiration date for the serial number or lot
                          number of the item associated with this item line, in
                          ISO 8601 format (YYYY-MM-DD). This is particularly
                          relevant for perishable or time-sensitive inventory
                          items. Note that this field is only supported on
                          QuickBooks Desktop 2023 or later.
                        example: '2025-12-31'
                      description:
                        type: string
                        description: A description of this item line.
                        example: High-quality widget with custom engraving
                      quantity:
                        type: number
                        description: >-
                          The quantity of the item associated with this item
                          line. This field cannot be cleared.


                          **NOTE**: Do not use this field if the associated item
                          is a discount item.
                        example: 5
                      unitOfMeasure:
                        type: string
                        description: >-
                          The unit-of-measure used for the `quantity` in this
                          item line. Must be a valid unit within the item's
                          available units of measure.
                        example: Each
                      cost:
                        type: string
                        description: >-
                          The cost of this item line, represented as a decimal
                          string. If both `quantity` and `amount` are specified
                          but not `cost`, QuickBooks will use them to calculate
                          `cost`.
                        example: '1000.00'
                      amount:
                        type: string
                        description: >-
                          The monetary amount of this item line, represented as
                          a decimal string. If both `quantity` and `cost` are
                          specified but not `amount`, QuickBooks will use them
                          to calculate `amount`. If `amount`, `cost`, and
                          `quantity` are all unspecified, then QuickBooks will
                          calculate `amount` based on a `quantity` of `1` and
                          the suggested `cost`. This field cannot be cleared.
                        example: '1000.00'
                      customerId:
                        type: string
                        description: >-
                          The customer or customer-job associated with this item
                          line.
                        example: 80000001-1234567890
                      classId:
                        type: string
                        description: >-
                          The item line's class. Classes can be used to
                          categorize objects into meaningful segments, such as
                          department, location, or type of work. In QuickBooks,
                          class tracking is off by default. If a class is
                          specified for the entire parent transaction, it is
                          automatically applied to all item lines unless
                          overridden here, at the transaction line level.
                        example: 80000001-1234567890
                      salesTaxCodeId:
                        type: string
                        description: >-
                          The sales-tax code for this item line, determining
                          whether it is taxable or non-taxable. If set, this
                          overrides any sales-tax codes defined on the parent
                          transaction or the associated item.


                          Default codes include "Non" (non-taxable) and "Tax"
                          (taxable), but custom codes can also be created in
                          QuickBooks. If QuickBooks is not set up to charge
                          sales tax (via the "Do You Charge Sales Tax?"
                          preference), it will assign the default non-taxable
                          code to all sales.
                        example: 80000001-1234567890
                      billingStatus:
                        type: string
                        enum:
                          - billable
                          - has_been_billed
                          - not_billable
                        description: The billing status of this item line.
                        example: billable
                        default: billable
                      overrideItemAccountId:
                        type: string
                        description: >-
                          The account to use for this item line, overriding the
                          default account associated with the item.
                        example: 80000001-1234567890
                      linkToTransactionLine:
                        type: object
                        properties:
                          transactionId:
                            type: string
                            description: >-
                              The ID of the transaction to which to link this
                              transaction.
                            example: 123ABC-1234567890
                          transactionLineId:
                            type: string
                            description: >-
                              The ID of the transaction line to which to link
                              this transaction.
                            example: 456DEF-1234567890
                        required:
                          - transactionId
                          - transactionLineId
                        additionalProperties: false
                        description: >-
                          An existing transaction line that you wish to link to
                          this item line. Note that this only links to a single
                          transaction line item, not an entire transaction. If
                          you want to link an entire transaction and bring in
                          all its lines, instead use the field
                          `linkToTransactionIds` on the parent transaction, if
                          available. If the parent transaction is a bill or an
                          item receipt, you can only link to purchase orders;
                          QuickBooks does not support linking these transactions
                          to other transaction types.


                          Transaction lines can only be linked when creating
                          this item line and cannot be unlinked later.


                          **IMPORTANT**: If you use `linkToTransactionLine` on
                          this item line, you cannot use the field `item` on
                          this line (QuickBooks will return an error) because
                          this field brings in all of the item information you
                          need. You can, however, specify whatever `quantity` or
                          `rate` that you want, or any other transaction line
                          element other than `item`.


                          If the parent transaction supports the
                          `linkToTransactionIds` field, you can use both
                          `linkToTransactionLine` (on this item line) and
                          `linkToTransactionIds` (on its parent transaction) in
                          the same request as long as they do NOT link to the
                          same transaction (otherwise, QuickBooks will return an
                          error). QuickBooks will also return an error if you
                          attempt to link a transaction that is empty or already
                          closed.


                          **IMPORTANT**: By default, QuickBooks will not return
                          any information about the linked transaction line in
                          this endpoint's response even when this request is
                          successful. To see the transaction line linked via
                          this field, refetch the parent transaction and check
                          the `linkedTransactions` response field. If fetching a
                          list of transactions, you must also specify the
                          parameter `includeLinkedTransactions=true` to see the
                          `linkedTransactions` response field.
                      salesRepresentativeId:
                        type: string
                        description: >-
                          The item line's sales representative. Sales
                          representatives can be employees, vendors, or other
                          names in QuickBooks.
                        example: 80000001-1234567890
                      customFields:
                        type: array
                        items:
                          type: object
                          properties:
                            ownerId:
                              type: string
                              description: >-
                                The identifier of the owner of the custom field,
                                which QuickBooks internally calls a "data
                                extension". For public custom fields visible in
                                the UI, such as those added by the QuickBooks
                                user, this is always "0". For private custom
                                fields that are only visible to the application
                                that created them, this is a valid GUID
                                identifying the owning application. Internally,
                                Conductor always fetches all public custom
                                fields (those with an `ownerId` of "0") for all
                                objects.
                              example: '0'
                            name:
                              type: string
                              description: >-
                                The name of the custom field, unique for the
                                specified `ownerId`. For public custom fields,
                                this name is visible as a label in the
                                QuickBooks UI.
                              example: Customer Rating
                            value:
                              type: string
                              description: >-
                                The value of this custom field. The maximum
                                length depends on the field's data type.
                              example: Premium
                          required:
                            - ownerId
                            - name
                            - value
                          additionalProperties: false
                        minItems: 1
                        description: >-
                          The custom fields for the item line object, added as
                          user-defined data extensions, not included in the
                          standard QuickBooks object.
                    additionalProperties: false
                  minItems: 1
                  description: >-
                    The credit card credit's item lines, each representing the
                    purchase of a specific item or service.
                itemGroupLines:
                  type: array
                  items:
                    type: object
                    properties:
                      itemGroupId:
                        type: string
                        description: >-
                          The item group line's item group, representing a
                          predefined set of items bundled because they are
                          commonly purchased together or grouped for faster
                          entry.
                        example: 80000001-1234567890
                      quantity:
                        type: number
                        description: >-
                          The quantity of the item group associated with this
                          item group line. This field cannot be cleared.


                          **NOTE**: Do not use this field if the associated item
                          group is a discount item group.
                        example: 5
                      unitOfMeasure:
                        type: string
                        description: >-
                          The unit-of-measure used for the `quantity` in this
                          item group line. Must be a valid unit within the
                          item's available units of measure.
                        example: Each
                      inventorySiteId:
                        type: string
                        description: >-
                          The site location where inventory for the item group
                          associated with this item group line is stored.
                        example: 80000001-1234567890
                      inventorySiteLocationId:
                        type: string
                        description: >-
                          The specific location (e.g., bin or shelf) within the
                          inventory site where the item group associated with
                          this item group line is stored.
                        example: 80000001-1234567890
                      customFields:
                        type: array
                        items:
                          type: object
                          properties:
                            ownerId:
                              type: string
                              description: >-
                                The identifier of the owner of the custom field,
                                which QuickBooks internally calls a "data
                                extension". For public custom fields visible in
                                the UI, such as those added by the QuickBooks
                                user, this is always "0". For private custom
                                fields that are only visible to the application
                                that created them, this is a valid GUID
                                identifying the owning application. Internally,
                                Conductor always fetches all public custom
                                fields (those with an `ownerId` of "0") for all
                                objects.
                              example: '0'
                            name:
                              type: string
                              description: >-
                                The name of the custom field, unique for the
                                specified `ownerId`. For public custom fields,
                                this name is visible as a label in the
                                QuickBooks UI.
                              example: Customer Rating
                            value:
                              type: string
                              description: >-
                                The value of this custom field. The maximum
                                length depends on the field's data type.
                              example: Premium
                          required:
                            - ownerId
                            - name
                            - value
                          additionalProperties: false
                        minItems: 1
                        description: >-
                          The custom fields for the item group line object,
                          added as user-defined data extensions, not included in
                          the standard QuickBooks object.
                    required:
                      - itemGroupId
                    additionalProperties: false
                  minItems: 1
                  description: >-
                    The credit card credit's item group lines, each representing
                    a predefined set of items bundled together because they are
                    commonly purchased together or grouped for faster entry.
              required:
                - accountId
                - transactionDate
              additionalProperties: false
      responses:
        '200':
          description: Returns the newly created credit card credit.
          headers:
            Conductor-Request-Id:
              schema:
                type: string
                description: The unique identifier for this API request.
                example: req_1234567abcdefg
              required: true
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/qbd_credit_card_credit'
      security:
        - BearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Conductor from 'conductor-node';


            const conductor = new Conductor({
              apiKey: process.env['CONDUCTOR_SECRET_KEY'], // This is the default and can be omitted
            });


            const creditCardCredit = await
            conductor.qbd.creditCardCredits.create({
              accountId: '80000001-1234567890',
              transactionDate: '2024-10-01',
              conductorEndUserId: 'end_usr_1234567abcdefg',
            });


            console.log(creditCardCredit.id);
        - lang: Python
          source: |-
            import os
            from datetime import date
            from conductor import Conductor

            conductor = Conductor(
                api_key=os.environ.get("CONDUCTOR_SECRET_KEY"),  # This is the default and can be omitted
            )
            credit_card_credit = conductor.qbd.credit_card_credits.create(
                account_id="80000001-1234567890",
                transaction_date=date.fromisoformat("2024-10-01"),
                conductor_end_user_id="end_usr_1234567abcdefg",
            )
            print(credit_card_credit.id)
components:
  schemas:
    qbd_credit_card_credit:
      type: object
      properties:
        id:
          type: string
          description: >-
            The unique identifier assigned by QuickBooks to this credit card
            credit. This ID is unique across all transaction types.
          example: 123ABC-1234567890
        objectType:
          type: string
          const: qbd_credit_card_credit
          description: The type of object. This value is always `"qbd_credit_card_credit"`.
          example: qbd_credit_card_credit
        createdAt:
          type: string
          description: >-
            The date and time when this credit card credit was created, in ISO
            8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks Desktop
            interprets in the local timezone of the end-user's computer.
          example: '2025-01-01T12:34:56.000Z'
        updatedAt:
          type: string
          description: >-
            The date and time when this credit card credit was last updated, in
            ISO 8601 format (YYYY-MM-DDThh:mm:ss±hh:mm), which QuickBooks
            Desktop interprets in the local timezone of the end-user's computer.
          example: '2025-02-01T12:34:56.000Z'
        revisionNumber:
          type: string
          description: >-
            The current QuickBooks-assigned revision number of this credit card
            credit object, which changes each time the object is modified. When
            updating this object, you must provide the most recent
            `revisionNumber` to ensure you're working with the latest data;
            otherwise, the update will return an error.
          example: '1721172183'
        account:
          type: object
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The bank or credit card account to which this credit card credit is
            posted.
          example:
            id: 80000001-1234567890
            fullName: Visa
        payee:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The vendor or company from whom this credit card credit was received
            for purchased merchandise or services.
          example:
            id: 80000001-1234567890
            fullName: Office Depot
        transactionDate:
          type: string
          format: date
          description: >-
            The date of this credit card credit, in ISO 8601 format
            (YYYY-MM-DD).
          example: '2024-10-01'
        amount:
          type: string
          description: >-
            The total monetary amount of this credit card credit, represented as
            a decimal string. This equals the sum of the amounts in the credit
            card credit's expense lines, item lines, and item group lines.
          example: '1000.00'
        currency:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The credit card credit's currency. For built-in currencies, the name
            and code are standard ISO 4217 international values. For
            user-defined currencies, all values are editable.
          example:
            id: 80000001-1234567890
            fullName: USD
        exchangeRate:
          type:
            - number
            - 'null'
          description: >-
            The market exchange rate between this credit card credit's currency
            and the home currency in QuickBooks at the time of this transaction.
            Represented as a decimal value (e.g., 1.2345 for 1 EUR = 1.2345 USD
            if USD is the home currency).
          example: 1.2345
        amountInHomeCurrency:
          type:
            - string
            - 'null'
          description: >-
            The monetary amount of this credit card credit converted to the home
            currency of the QuickBooks company file. Represented as a decimal
            string.
          example: '1234.56'
        refNumber:
          type:
            - string
            - 'null'
          description: >-
            The case-sensitive user-defined reference number for this credit
            card credit, which can be used to identify the transaction in
            QuickBooks. This value is not required to be unique and can be
            arbitrarily changed by the QuickBooks user.
          example: CREDIT-1234
        memo:
          type:
            - string
            - 'null'
          description: A memo or note for this credit card credit.
          example: Refund for returned office supplies
        salesTaxCode:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The sales-tax code for this credit card credit, determining whether
            it is taxable or non-taxable. If set, this overrides any sales-tax
            codes defined on the payee. This can be overridden on the credit
            card credit's individual lines.


            Default codes include "Non" (non-taxable) and "Tax" (taxable), but
            custom codes can also be created in QuickBooks. If QuickBooks is not
            set up to charge sales tax (via the "Do You Charge Sales Tax?"
            preference), it will assign the default non-taxable code to all
            sales.
          example:
            id: 80000001-1234567890
            fullName: Non
        externalId:
          type:
            - string
            - 'null'
          description: >-
            A globally unique identifier (GUID) you, the developer, can provide
            for tracking this object in your external system. This field is
            immutable and can only be set during object creation.
          example: 12345678-abcd-1234-abcd-1234567890ab
        expenseLines:
          type: array
          items:
            $ref: '#/components/schemas/qbd_expense_line'
          description: >-
            The credit card credit's expense lines, each representing one line
            in this expense.
        itemLines:
          type: array
          items:
            $ref: '#/components/schemas/qbd_item_line'
          description: >-
            The credit card credit's item lines, each representing the purchase
            of a specific item or service.
        itemGroupLines:
          type: array
          items:
            $ref: '#/components/schemas/qbd_item_group_line_item'
          description: >-
            The credit card credit's item group lines, each representing a
            predefined set of items bundled together because they are commonly
            purchased together or grouped for faster entry.
        customFields:
          type: array
          items:
            $ref: '#/components/schemas/qbd_custom_field'
          description: >-
            The custom fields for the credit card credit object, added as
            user-defined data extensions, not included in the standard
            QuickBooks object.
      required:
        - id
        - objectType
        - createdAt
        - updatedAt
        - revisionNumber
        - account
        - payee
        - transactionDate
        - amount
        - currency
        - exchangeRate
        - amountInHomeCurrency
        - refNumber
        - memo
        - salesTaxCode
        - externalId
        - expenseLines
        - itemLines
        - itemGroupLines
        - customFields
      additionalProperties: false
      title: The Credit Card Credit object
      x-conductor-object-type: transaction
      summary: >-
        A credit card credit represents a credit or refund received from a
        vendor for returned merchandise, billing adjustment, or other credit. It
        reduces the balance owed on the credit card account.
    qbd_expense_line:
      type: object
      properties:
        id:
          type: string
          description: >-
            The unique identifier assigned by QuickBooks to this expense line.
            This ID is unique across all transaction line types.
          example: 456DEF-1234567890
        objectType:
          type: string
          const: qbd_expense_line
          description: The type of object. This value is always `"qbd_expense_line"`.
          example: qbd_expense_line
        account:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The expense account being debited (increased) for this expense line.
            The corresponding account being credited is usually a liability
            account (e.g., Accounts-Payable) or an asset account (e.g., Cash),
            depending on the transaction type.
          example:
            id: 80000001-1234567890
            fullName: Expenses:Office Supplies
        amount:
          type:
            - string
            - 'null'
          description: >-
            The monetary amount of this expense line, represented as a decimal
            string.
          example: '1000.00'
        memo:
          type:
            - string
            - 'null'
          description: A memo or note for this expense line.
          example: New office chair
        payee:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            If `account` refers to an Accounts-Payable (A/P) account, `payee`
            refers to the expense's vendor (not the customer). If `account`
            refers to any other type of account, `payee` refers to the expense's
            customer (not the vendor).
          example:
            id: 80000001-1234567890
            fullName: Acme Corporation
        class:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The expense line's class. Classes can be used to categorize objects
            into meaningful segments, such as department, location, or type of
            work. In QuickBooks, class tracking is off by default. If a class is
            specified for the entire parent transaction, it is automatically
            applied to all expense lines unless overridden here, at the
            transaction line level.
          example:
            id: 80000001-1234567890
            fullName: Office Supplies
        salesTaxCode:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The sales-tax code for this expense line, determining whether it is
            taxable or non-taxable. If set, this overrides any sales-tax codes
            defined on the parent transaction or the associated item.


            Default codes include "Non" (non-taxable) and "Tax" (taxable), but
            custom codes can also be created in QuickBooks. If QuickBooks is not
            set up to charge sales tax (via the "Do You Charge Sales Tax?"
            preference), it will assign the default non-taxable code to all
            sales.
          example:
            id: 80000001-1234567890
            fullName: Non
        billingStatus:
          type:
            - string
            - 'null'
          enum:
            - billable
            - has_been_billed
            - not_billable
            - null
          description: The billing status of this expense line.
          example: billable
        salesRepresentative:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The expense line's sales representative. Sales representatives can
            be employees, vendors, or other names in QuickBooks.
          example:
            id: 80000001-1234567890
            fullName: Jane Doe
        customFields:
          type: array
          items:
            $ref: '#/components/schemas/qbd_custom_field'
          description: >-
            The custom fields for the expense line object, added as user-defined
            data extensions, not included in the standard QuickBooks object.
      required:
        - id
        - objectType
        - account
        - amount
        - memo
        - payee
        - class
        - salesTaxCode
        - billingStatus
        - salesRepresentative
        - customFields
      additionalProperties: false
      title: The Expense Line object
      x-conductor-object-type: nested
    qbd_item_line:
      type: object
      properties:
        id:
          type: string
          description: >-
            The unique identifier assigned by QuickBooks to this item line. This
            ID is unique across all transaction line types.
          example: 456DEF-1234567890
        objectType:
          type: string
          const: qbd_item_line
          description: The type of object. This value is always `"qbd_item_line"`.
          example: qbd_item_line
        item:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The item associated with this item line. This can refer to any good
            or service that the business buys or sells, including item types
            such as a service item, inventory item, or special calculation item
            like a discount item or sales-tax item.
          example:
            id: 80000001-1234567890
            fullName: Widget A
        inventorySite:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The site location where inventory for the item associated with this
            item line is stored.
          example:
            id: 80000001-1234567890
            fullName: Main Warehouse
        inventorySiteLocation:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The specific location (e.g., bin or shelf) within the inventory site
            where the item associated with this item line is stored.
          example:
            id: 80000001-1234567890
            fullName: Aisle 3, Shelf B
        serialNumber:
          type:
            - string
            - 'null'
          description: >-
            The serial number of the item associated with this item line. This
            is used for tracking individual units of serialized inventory items.
          example: SN1234567890
        lotNumber:
          type:
            - string
            - 'null'
          description: >-
            The lot number of the item associated with this item line. Used for
            tracking groups of inventory items that are purchased or
            manufactured together.
          example: LOT2023-001
        expirationDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            The expiration date for the serial number or lot number of the item
            associated with this item line, in ISO 8601 format (YYYY-MM-DD).
            This is particularly relevant for perishable or time-sensitive
            inventory items. Note that this field is only supported on
            QuickBooks Desktop 2023 or later.
          example: '2025-12-31'
        description:
          type:
            - string
            - 'null'
          description: A description of this item line.
          example: High-quality widget with custom engraving
        quantity:
          type:
            - number
            - 'null'
          description: >-
            The quantity of the item associated with this item line. This field
            cannot be cleared.


            **NOTE**: Do not use this field if the associated item is a discount
            item.
          example: 5
        unitOfMeasure:
          type:
            - string
            - 'null'
          description: >-
            The unit-of-measure used for the `quantity` in this item line. Must
            be a valid unit within the item's available units of measure.
          example: Each
        overrideUnitOfMeasureSet:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            Specifies an alternative unit-of-measure set when updating this item
            line's `unitOfMeasure` field (e.g., "pound" or "kilogram"). This
            allows you to select units from a different set than the item's
            default unit-of-measure set, which remains unchanged on the item
            itself. The override applies only to this specific line. For
            example, you can sell an item typically measured in volume units
            using weight units in a specific transaction by specifying a
            different unit-of-measure set with this field.
          example:
            id: 80000001-1234567890
            fullName: Volume Units
        cost:
          type:
            - string
            - 'null'
          description: >-
            The cost of this item line, represented as a decimal string. If both
            `quantity` and `amount` are specified but not `cost`, QuickBooks
            will use them to calculate `cost`.
          example: '1000.00'
        amount:
          type:
            - string
            - 'null'
          description: >-
            The monetary amount of this item line, represented as a decimal
            string. If both `quantity` and `cost` are specified but not
            `amount`, QuickBooks will use them to calculate `amount`. If
            `amount`, `cost`, and `quantity` are all unspecified, then
            QuickBooks will calculate `amount` based on a `quantity` of `1` and
            the suggested `cost`. This field cannot be cleared.
          example: '1000.00'
        customer:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: The customer or customer-job associated with this item line.
          example:
            id: 80000001-1234567890
            fullName: Acme Corporation
        class:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The item line's class. Classes can be used to categorize objects
            into meaningful segments, such as department, location, or type of
            work. In QuickBooks, class tracking is off by default. If a class is
            specified for the entire parent transaction, it is automatically
            applied to all item lines unless overridden here, at the transaction
            line level.
          example:
            id: 80000001-1234567890
            fullName: Installation:Residential
        salesTaxCode:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The sales-tax code for this item line, determining whether it is
            taxable or non-taxable. If set, this overrides any sales-tax codes
            defined on the parent transaction or the associated item.


            Default codes include "Non" (non-taxable) and "Tax" (taxable), but
            custom codes can also be created in QuickBooks. If QuickBooks is not
            set up to charge sales tax (via the "Do You Charge Sales Tax?"
            preference), it will assign the default non-taxable code to all
            sales.
          example:
            id: 80000001-1234567890
            fullName: Non
        billingStatus:
          type:
            - string
            - 'null'
          enum:
            - billable
            - has_been_billed
            - not_billable
            - null
          description: The billing status of this item line.
          example: billable
        salesRepresentative:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The item line's sales representative. Sales representatives can be
            employees, vendors, or other names in QuickBooks.
          example:
            id: 80000001-1234567890
            fullName: Jane Doe
        customFields:
          type: array
          items:
            $ref: '#/components/schemas/qbd_custom_field'
          description: >-
            The custom fields for the item line object, added as user-defined
            data extensions, not included in the standard QuickBooks object.
      required:
        - id
        - objectType
        - item
        - inventorySite
        - inventorySiteLocation
        - serialNumber
        - lotNumber
        - expirationDate
        - description
        - quantity
        - unitOfMeasure
        - overrideUnitOfMeasureSet
        - cost
        - amount
        - customer
        - class
        - salesTaxCode
        - billingStatus
        - salesRepresentative
        - customFields
      additionalProperties: false
      title: The Item Line object
      x-conductor-object-type: nested
    qbd_item_group_line_item:
      type: object
      properties:
        id:
          type: string
          description: >-
            The unique identifier assigned by QuickBooks to this item group
            line. This ID is unique across all transaction line types.
          example: 456DEF-1234567890
        objectType:
          type: string
          const: qbd_item_group_line
          description: The type of object. This value is always `"qbd_item_group_line"`.
          example: qbd_item_group_line
        itemGroup:
          type: object
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            The item group line's item group, representing a predefined set of
            items bundled because they are commonly purchased together or
            grouped for faster entry.
          example:
            id: 80000001-1234567890
            fullName: Office Supplies Bundle
        description:
          type:
            - string
            - 'null'
          description: A description of this item group line.
          example: Standard widget bulk package
        quantity:
          type:
            - number
            - 'null'
          description: >-
            The quantity of the item group associated with this item group line.
            This field cannot be cleared.


            **NOTE**: Do not use this field if the associated item group is a
            discount item group.
          example: 5
        unitOfMeasure:
          type:
            - string
            - 'null'
          description: >-
            The unit-of-measure used for the `quantity` in this item group line.
            Must be a valid unit within the item's available units of measure.
          example: Each
        overrideUnitOfMeasureSet:
          type:
            - object
            - 'null'
          properties:
            id:
              type:
                - string
                - 'null'
              description: >-
                The unique identifier assigned by QuickBooks to this object.
                This ID is unique across all objects of the same type, but not
                across different QuickBooks object types.
              example: 80000001-1234567890
            fullName:
              type:
                - string
                - 'null'
              description: >-
                The fully-qualified unique name for this object, formed by
                combining the names of its parent objects with its own `name`,
                separated by colons. Not case-sensitive.
              example: Parent:Child:Grandchild
          required:
            - id
            - fullName
          additionalProperties: false
          description: >-
            Specifies an alternative unit-of-measure set when updating this item
            group line's `unitOfMeasure` field (e.g., "pound" or "kilogram").
            This allows you to select units from a different set than the item's
            default unit-of-measure set, which remains unchanged on the item
            itself. The override applies only to this specific line. For
            example, you can sell an item typically measured in volume units
            using weight units in a specific transaction by specifying a
            different unit-of-measure set with this field.
          example:
            id: 80000001-1234567890
            fullName: Volume Units
        totalAmount:
          type: string
          description: >-
            The total monetary amount of this item group line, equivalent to the
            sum of the amounts in `lines`, represented as a decimal string.
          example: '1000.00'
        itemLines:
          type: array
          items:
            $ref: '#/components/schemas/qbd_item_line'
          description: >-
            The item group line's item lines, each representing the purchase of
            a specific item or service.
        customFields:
          type: array
          items:
            $ref: '#/components/schemas/qbd_custom_field'
          description: >-
            The custom fields for the item group line object, added as
            user-defined data extensions, not included in the standard
            QuickBooks object.
      required:
        - id
        - objectType
        - itemGroup
        - description
        - quantity
        - unitOfMeasure
        - overrideUnitOfMeasureSet
        - totalAmount
        - itemLines
        - customFields
      additionalProperties: false
      title: The Item Group Line object
      x-conductor-object-type: nested
    qbd_custom_field:
      type: object
      properties:
        ownerId:
          type: string
          description: >-
            The identifier of the owner of the custom field, which QuickBooks
            internally calls a "data extension". For public custom fields
            visible in the UI, such as those added by the QuickBooks user, this
            is always "0". For private custom fields that are only visible to
            the application that created them, this is a valid GUID identifying
            the owning application. Internally, Conductor always fetches all
            public custom fields (those with an `ownerId` of "0") for all
            objects.
          example: '0'
        name:
          type: string
          description: >-
            The name of the custom field, unique for the specified `ownerId`.
            For public custom fields, this name is visible as a label in the
            QuickBooks UI.
          example: Customer Rating
        type:
          type: string
          enum:
            - amount_type
            - date_time_type
            - integer_type
            - percent_type
            - price_type
            - quantity_type
            - string_1024_type
            - string_255_type
          description: The data type of this custom field.
          example: string_1024_type
        value:
          type: string
          description: >-
            The value of this custom field. The maximum length depends on the
            field's data type.
          example: Premium
      required:
        - ownerId
        - name
        - type
        - value
      additionalProperties: false
      title: The Custom Field object
      x-conductor-object-type: nested
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      description: >-
        Your Conductor secret key using Bearer auth (e.g., `"Authorization:
        Bearer {{YOUR_SECRET_KEY}}"`).

````

Built with [Mintlify](https://mintlify.com).